/*
 *     This file is part of the Squashtest platform.
 *     Copyright (C) Henix, henix.fr
 *
 *     See the NOTICE file distributed with this work for additional
 *     information regarding copyright ownership.
 *
 *     This is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU Lesser General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     this software is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU Lesser General Public License for more details.
 *
 *     You should have received a copy of the GNU Lesser General Public License
 *     along with this software.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.squashtest.tm.service.testautomation.resultpublisher;

import java.util.List;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;
import javax.inject.Inject;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.squashtest.tm.core.foundation.logger.Logger;
import org.squashtest.tm.core.foundation.logger.LoggerFactory;
import org.squashtest.tm.domain.testautomation.AutomatedSuite;
import org.squashtest.tm.domain.users.ApiToken;
import org.squashtest.tm.service.internal.repository.ApiTokenDao;
import org.squashtest.tm.service.internal.repository.AutomatedSuiteDao;
import org.squashtest.tm.service.testautomation.model.AutomatedExecutionState;

@Service
@Transactional
public class ResultPublicationServiceImpl implements ResultPublicationService {

    private static final Logger LOGGER = LoggerFactory.getLogger(ResultPublicationServiceImpl.class);
    private static final long DELAY = TimeUnit.HOURS.toHours(1);
    private static final TimeUnit TIME_UNIT = TimeUnit.HOURS;

    @Inject private AutomatedSuiteDao autoSuiteDao;
    @Inject private ExecutionService executionService;
    @Inject private ApiTokenDao apiTokenDao;

    @Override
    public void publishResult(String suiteId, long testId, AutomatedExecutionState stateChange) {
        AutomatedSuite automatedSuite = autoSuiteDao.findById(suiteId);
        if (stateChange.isLastUpdate()) {
            automatedSuite.setWorkflows(null);
            deleteAutoGeneratedToken(suiteId);
        }
        executionService.updateExecutionAndClearSession(testId, suiteId, stateChange);
    }

    protected void deleteAutoGeneratedToken(String automatedSuiteId) {
        if (autoSuiteDao.isAutomatedSuiteCreatedByTestAutomationServerUser(automatedSuiteId)) {
            return;
        }
        String tokenPartialName = "-" + automatedSuiteId + "-";
        scheduleTokenDeletion(tokenPartialName);
    }

    protected void scheduleTokenDeletion(String tokenPartialName) {
        if (!hasFoundTokenToDelete(tokenPartialName)) {
            return;
        }
        ScheduledExecutorService scheduler = Executors.newScheduledThreadPool(1);
        scheduler.schedule(
                () -> apiTokenDao.deleteAllByNameContains(tokenPartialName), DELAY, TIME_UNIT);
        scheduler.shutdown();
    }

    protected boolean hasFoundTokenToDelete(String tokenPartialName) {
        List<ApiToken> tokens = apiTokenDao.findAllByNameContains(tokenPartialName);
        if (tokens == null || tokens.isEmpty()) {
            LOGGER.trace(
                    "No token found matching the pattern '{}', associated with the automated suite.",
                    tokenPartialName);
            return false;
        } else if (tokens.size() > 1) {
            LOGGER.warn(
                    "Multiple tokens matching the pattern '{}' were found. All will be scheduled for deletion.",
                    tokenPartialName);
        }
        return true;
    }
}
